// USB Listener thread
USBListener usbEvent;
byte[] input_buffer = new byte[64];
byte[] output_buffer = new byte[65];
byte[] output_packet = new byte[100];
int[] rxBuffer = new int[8000];
int rxBufferIndex = 0;
int sendData = 0;
int iiusb = 0;
int numInPacket = 0;
int num = 0;
int got13 = 0;
int gotNewData = 0;
int j = 0;

private class USBListener extends Thread 
{
  public void run()
  {
    while (true)
    {
      if (picConnected) {
        try
        {
          int datalen=0;
          int i=0;

          if (sendData==1) {
            output_packet[1] = byte(0); // start
            output_packet[2] = byte((ToPic.PowerOn<<6&0x40)|(ToPic.SensA<<3&0x38)|(ToPic.SensB&0x07)); // PowerOn, SensA, SensB
            output_packet[3] = byte(ToPic.NumDataPoints>>8&0xFF); // NumDataPoints high
            output_packet[4] = byte(ToPic.NumDataPoints&0xFF); // NumDataPoints low
            
            output_packet[5] = byte(ToPic.SampleRate>>24&0xFF); // SampleRate MSB
            output_packet[6] = byte(ToPic.SampleRate>>16&0xFF); // SampleRate 
            output_packet[7] = byte(ToPic.SampleRate>>8&0xFF); // SampleRate
            output_packet[8] = byte(ToPic.SampleRate&0xFF); // SampleRate low
            
            output_packet[9] = byte(ToPic.FnType&0xFF); // FnType
            output_packet[10] = byte(ToPic.FnFreq>>8&0xFF); // FnFreq high
            output_packet[11] = byte(ToPic.FnFreq&0xFF); // FnFreq low
            output_packet[12] = byte(ToPic.DigType&0xFF); // DigType
            output_packet[13] = byte(ToPic.DigFreq>>8&0xFF); // DigFreq high
            output_packet[14] = byte(ToPic.DigFreq&0xFF); // DigFreq low
            output_packet[15] = byte(ToPic.TrigType&0xFF); // TrigType
            output_packet[16] = byte(ToPic.TrigLevel&0xFF); // TrigLevel
            
            output_packet[17] = byte(0); // DigDelay high
            output_packet[18] = byte(0); // DigDelay low
            
            output_packet[19] = byte(255); // end

            // doesn't matter what you put in index 0
            // index 1 later gets lenght of packet
            numInPacket = 2; 
            output_buffer[numInPacket] = byte(13); // special character
            //print(int(output_buffer[numInPacket]));
            //print(',');
            numInPacket++;
            output_buffer[numInPacket] = byte(0); // start
            //print(int(output_buffer[numInPacket]));
            //print(',');
            numInPacket++;
            for (iiusb=2;iiusb<15;iiusb++) {
              if (output_packet[iiusb]==13) {
                output_buffer[numInPacket] = 13;
                //print(int(output_buffer[numInPacket]));
                //print(',');
                numInPacket++;
                output_buffer[numInPacket] = output_packet[iiusb];
                //print(int(output_buffer[numInPacket]));
                //print(',');
                numInPacket++;
              }
              else {
                output_buffer[numInPacket] = output_packet[iiusb];
                //print(int(output_buffer[numInPacket]));
                //print(',');
                numInPacket++;
              }
            }
            output_buffer[numInPacket] = byte(13); // special character
            //print(int(output_buffer[numInPacket]));
            //print(',');
            numInPacket++;
            output_buffer[numInPacket] = byte(255); // end
            //print(int(output_buffer[numInPacket]));
            //print(",   ");
            
            output_buffer[1] = byte(numInPacket);
            output_buffer[0] = byte(0);
            //println(numInPacket);

            pic.write(output_buffer); // warning - no check to make sure there are less than 64 bytes
            //println("Sent a message");
            sendData = 0;
          }

          pic.read(input_buffer);

          // The number of meaningful bytes is
          // stored in the zeroth byte
          datalen = (int)input_buffer[0]; // includes length          
          if (datalen > 0) {
            //println("Got a message!");
            //print("raw buff = ");
            //for(i=1;i<datalen;i++) {
            //  print(int(input_buffer[i]));
            //  print(" ");
            //}
            //println(" ");
            //got13 = 0;
            for (i=1;i<datalen;i++) {
              if(got13 == 1) {
                if(int(input_buffer[i]) == 0) {
                  rxBufferIndex = 0;
                  got13 = 0;
                }
                else if (int(input_buffer[i]) == 255) {
                  gotNewData = 1;
                  rxBufferIndex = 0;
                  got13 = 0;
                }
                else if (int(input_buffer[i]) == 13) {
                  rxBuffer[rxBufferIndex] = 13;
                  rxBufferIndex++;
                  got13 = 0;
                }
              }
              else if(int(input_buffer[i]) == 13) {
                got13 = 1;
              }
              else {
                rxBuffer[rxBufferIndex] = int(input_buffer[i]);
                rxBufferIndex++;
                got13 = 0;
              }
            }

            if (gotNewData == 1) {
              gotNewData = 0;
              //print("rx buff = ");
              //for(i=0;i<rxBufferIndex;i++) {
              //  print(rxBuffer[i]);
              //  print(',');
              //}
              //println(" ");
              
              ToPic.PowerOn = rxBuffer[0];
              if(ToPic.PowerOn == 1) {
                cbxPowerOn.setSelected(true);
              }
              else {
                cbxPowerOn.setSelected(false);
              }
              PowerUsage = (rxBuffer[1]<<8)+rxBuffer[2];
              //println(PowerUsage);
              DCount = (rxBuffer[3]<<8)+rxBuffer[4];
              DFreq = (rxBuffer[5]<<8)+rxBuffer[6];
              ToPic.gotNumDataPoints = (rxBuffer[7]<<8)+rxBuffer[8];
              if (ToPic.gotNumDataPoints < 750) {
                arrayCopy(dataA,ToPic.gotNumDataPoints,dataA,0,750-ToPic.gotNumDataPoints);
                arrayCopy(dataB,ToPic.gotNumDataPoints,dataB,0,750-ToPic.gotNumDataPoints);
                arrayCopy(dataD1,ToPic.gotNumDataPoints,dataD1,0,750-ToPic.gotNumDataPoints);
                arrayCopy(dataD2,ToPic.gotNumDataPoints,dataD2,0,750-ToPic.gotNumDataPoints);
                arrayCopy(dataD3,ToPic.gotNumDataPoints,dataD3,0,750-ToPic.gotNumDataPoints);
                arrayCopy(dataD4,ToPic.gotNumDataPoints,dataD4,0,750-ToPic.gotNumDataPoints);
                j = 0;
                for(i=750-ToPic.gotNumDataPoints;i<750;i++) {
                  dataA[i] = rxBuffer[9+j*4]+((rxBuffer[11+j*4]&0x0C)<<6);
                  dataB[i] = rxBuffer[10+j*4]+((rxBuffer[11+j*4]&0x03)<<8);
                  dataD4[i] = ((rxBuffer[12+j*4]&0x02)>>1)^1;
                  dataD3[i] = ((rxBuffer[12+j*4]&0x04)>>2)^1;
                  dataD2[i] = ((rxBuffer[12+j*4]&0x08)>>3)^1;
                  dataD1[i] = ((rxBuffer[12+j*4]&0x10)>>4)^1;
                  j++;
                }
                //dataIndex = 0;
              }
              else {
                for(i=dataIndex;i<ToPic.NumDataPoints+dataIndex;i++) {
                  dataA[i] = rxBuffer[9+i*4]+((rxBuffer[11+i*4]&0x0C)<<6);
                  dataB[i] = rxBuffer[10+i*4]+((rxBuffer[11+i*4]&0x03)<<8);
                  dataD4[i] = ((rxBuffer[12+i*4]&0x02)>>1)^1;
                  dataD3[i] = ((rxBuffer[12+i*4]&0x04)>>2)^1;
                  dataD2[i] = ((rxBuffer[12+i*4]&0x08)>>3)^1;
                  dataD1[i] = ((rxBuffer[12+i*4]&0x10)>>4)^1;
                }
                //dataIndex = dataIndex + ToPic.NumDataPoints;
              }
              //if (dataIndex > 745) {
              //  dataIndex = 0;
              //}
              
              if (stopAfterNextFill == 1) {
                optFreeze.setSelected(true);
                stopAfterNextFill = 0;
              }
              
              readyToAsk = 1;
              lastPacketTime = millis();
              /*
              print("PowerOn = ");
              println(ToPic.PowerOn);
              print("PowerUsage = ");
              println(PowerUsage);
              print("DCount = ");
              println(DCount);
              print("DFreq = ");
              println(DFreq);
              print("A = ");
              for(i=0;i<ToPic.NumDataPoints;i++) {
                print(dataA[i]);
                print(" ");
              }
              println(" ");
              print("B = ");
              for(i=0;i<ToPic.NumDataPoints;i++) {
                print(dataB[i]);
                print(" ");
              }
              println(" ");
              */
              //print("rxBufferIndex = ");
              //println(rxBufferIndex);
              /*
              print("D1 = ");
              for(i=0;i<ToPic.NumDataPoints;i++) {
                print(dataD1[i]);
                print(" ");
              }
              println(" ");
              print("D2 = ");
              for(i=0;i<ToPic.NumDataPoints;i++) {
                print(dataD2[i]);
                print(" ");
              }
              println(" ");
              print("D3 = ");
              for(i=0;i<ToPic.NumDataPoints;i++) {
                print(dataD3[i]);
                print(" ");
              }
              println(" ");
              print("D4 = ");
              for(i=0;i<ToPic.NumDataPoints;i++) {
                print(dataD4[i]);
                print(" ");
              }
              println(" ");
              */
            }
          }
        } 
        catch (Exception e) {
          if (picConnected) e.printStackTrace();
          println("Cannot Read From Device");
        }
      }
    }
  }
}

